#!/usr/bin/python

import array
import sys
import zlib
import time

COLLIDE_BINARY = 0
COLLIDE_ASCII = 1

def incr_ascii(buf):
	pos = len(buf)-1
	while pos >= 0:
		if buf[pos] == 0x7e:
			buf[pos] = 0x20
		else:
			buf[pos] += 1
			return
		pos -= 1
	buf.insert(0, 0x20)

def incr_binary(buf):
	pos = len(buf)-1
	while pos >= 0:
		if buf[pos] == 0xff:
			buf[pos] = 0
		else:
			buf[pos] += 1
			return
		pos -= 1
	buf.insert(0, 0)

def collide(type, target, mod):
	if type == COLLIDE_BINARY:
		buf = array.array('B', (0,))
		incr = incr_binary
	elif type == COLLIDE_ASCII:
		buf = array.array('B', (0x20,))
		incr = incr_ascii
	else: assert 0

	crc0 = zlib.crc32(target)
	crc1 = zlib.crc32(mod)

	i = 0
	while True:
		if i == 1048576:
			i = 0
			val = buf.tostring()
			if type != COLLIDE_ASCII:
				val = base64.b64encode(val)
			#print "'%s'" % val
		crc2 = zlib.crc32(buf, crc1)
		if crc0 == crc2:
			return buf.tostring()

		incr(buf)
		i += 1

targets = [
	'alpha',
#	'beta',
#	'gamma',
#	'delta',
#	'epsilon',
#	'zeta',
#	'eta',
#	'theta',
#	'iota',
]

type = COLLIDE_ASCII

mod = 'beta';
start=time.clock()
for target in targets:
	suffix = collide(type, target, mod)
	if type != COLLIDE_ASCII:
		suffix = base64.b64encode(suffix)
	end=time.clock()
	print "found collision for '%s': '%s%s' in %s seconds" % (target, mod, suffix, end-start)
	
